/*
 * Фискален бон
 * ============
 * 
 * Copyright © 2015 Златин Георгиев. All rights reserved.
 * 
 * СОФТУЕРЪТ СЕ ПРЕДОСТАВЯ "КАКЪВТО Е", БЕЗ ГАРАНЦИЯ ОТ КАКЪВТО И ДА Е ВИД,
 * ИЗРИЧНА ИЛИ КОСВЕНА, ВКЛЮЧИТЕЛНО БЕЗ ГАРАНЦИИ ЗА ПРОДАВАЕМОСТ, ГОДНОСТ ЗА
 * ОПРЕДЕЛЕНА ЦЕЛ И НЕНАРУШАВАНЕ. В НИКАКЪВ СЛУЧАЙ АВТОРИТЕ ИЛИ ПРИТЕЖАТЕЛЯ
 * НА АВТОРСКИТЕ ПРАВА НЕ НОСЯТ ОТГОВОРНОСТ ЗА КАКВИТО И ДА Е ИСКОВЕ, ПОВРЕДИ
 * ИЛИ ДРУГА ОТГОВОРНОСТ, НЕЗАВИСИМО ДАЛИ ПО СИЛАТА НА ДОГОВОР, ЗАКОНОНАРУШЕНИЕ
 * ИЛИ ПО ДРУГ НАЧИН, ОТ ИЛИ ВЪВ ВРЪЗКА СЪС СОФТУЕРА, ИЛИ ИЗПОЛЗВАНЕТО МУ, ИЛИ
 * ДРУГИ ОТНОШЕНИЯ КАСАЕЩИ СОФТУЕРА.
 */

var KasovBon;

if(KasovBon == undefined) {
	KasovBon = {};

	KasovBon.StartRequest = function() {
		$("#SaveButton").attr("disabled", "disabled");
		$("#ReportButton").attr("disabled", "disabled");
		$("#ArchiveButton").attr("disabled", "disabled");
		$("#RestoreButton").attr("disabled", "disabled");
		$("#CalcButton").attr("disabled", "disabled");
	};

	KasovBon.EndRequest = function() {
		$("#SaveButton").removeAttr("disabled");
		$("#ReportButton").removeAttr("disabled");
		$("#ArchiveButton").removeAttr("disabled");
		$("#RestoreButton").removeAttr("disabled");
		$("#CalcButton").removeAttr("disabled");
	};
	
	/**
	 *	ProcessRequest
	 *		type
	 *			save
	 *		name
	 *			SaveEntry
	 *		userName
	 *			Name
	 *		documentGroup
	 *			Group
	 *		documentType
	 *			Type
	 *		documentTotal
	 *			Total
	 *		documentDate
	 *			yyyymmdd
	 *		documentHour
	 *			hh (0-23)
	 *		documentMinute
	 *			mm (0-59)
	 *		documentMessage
	 *			Message
	 *	Result
	 *		id
	 *			ID
	 */
	KasovBon.saveEntry = function() {
		KasovBon.StartRequest();

		var userName = $("#userName").val();
		var documentGroup = $("#documentGroup").val();
		var documentType = $("#documentType").val();
		var documentTotal = parseFloat($("#documentTotal").val().toString().replace(",",".")).toFixed(2);
		if(isNaN(documentTotal) || documentTotal == "0.00") {
			KasovBon.EndRequest();

			alert("Не е зададена сума за документа!");

			return;
		}

		var date = $("#documentDate").datepicker("getDate");
		if(date == null) {
			KasovBon.EndRequest();

			alert("Невалидна дата!");

			return;
		}
		var day = date.getDate();
		var month = date.getMonth()+1;
		var year = date.getFullYear();
		var documentDate = year + (month<10?"0":"") + month.toString() + (day<10?"0":"") + day.toString();
		var documentHour = toInt(parseInt($("#documentHour").val().toString()), 2);
		var documentMinute = toInt(parseInt($("#documentMinute").val().toString()), 2);
		var documentMessage = $("#documentMessage").val();

		var forZZZ = {};
		forZZZ["type"] = "write";
		forZZZ["name"] = "SaveEntry";
		if(userName != "")
			forZZZ["userName"] = userName;
		forZZZ["documentGroup"] = documentGroup;
		forZZZ["documentType"] = documentType;
		if(!isNaN(documentTotal))
			forZZZ["documentTotal"] = documentTotal;
		forZZZ["documentDate"] = documentDate;
		if(!isNaN(documentHour))
			forZZZ["documentHour"] = documentHour;
		if(!isNaN(documentMinute))
			forZZZ["documentMinute"] = documentMinute;
		if(documentMessage != "")
			forZZZ["documentMessage"] = documentMessage;

		forZZZ["class"] = {};
		forZZZ["class"]["base"] = "KasovBonCLASSBASE";
		forZZZ["class"]["name"] = "KasovBonCLASSNAME";

		var zzzbase = "finance_zzzbase";
		var commands =	"#[cout;#[::>.;##[CoreCLASSBASE];##[CoreCLASSNAME];methods/public/ProcessRequest;["+zzzbase+";]\n";
		commands +=		"[[\n";
		commands +=		objectToZZZTXT(forZZZ, 0);
		commands +=		"]]]]";
		
		$.ajax({
			async: true,
			type: "POST",
			url: "zzzprog.ttm",
			contentType: "application/x-www-form-urlencoded;charset=UTF-8",
			data: {
				prog:""+commands
			}
		}).done(function(result) {
			var resultObject = zzztxtToObject(result);
			if(resultObject["errors"] == null && resultObject["result"] != null) {
				var documentNumber = parseInt(Object.keys(resultObject["result"]["number"])[0], 16);
				$("#documentNumber").val(documentNumber);

				$("#documentTotal").val("");
				return true;
			}
			KasovBon.EndRequest();
		});
	};
	
	/**
	 *	ProcessRequest
	 *		type
	 *			read
	 *		name
	 *			Report
	 *		userName
	 *			Name
	 *		documentDate
	 *			yyyymmdd
	 *		documentHour
	 *			hh (0-23)
	 *		documentMinute
	 *			mm (0-59)
	 *		documentMessage
	 *			Message
	 *	Result
	 *		id
	 *			ID
	 */
	KasovBon.report = function() {
		$("table.report tbody").empty();
				
		KasovBon.StartRequest();

		var userName = $("#userName").val();

		var date = $("#documentDate").val();
		if(date.length != 10) {
			KasovBon.EndRequest();

			alert("Невалидна дата!");

			return;
		}
		var day = date.substring(0,2);
		var month = date.substring(3,5);
		var year = date.substring(6,10);
		var documentDate = "".concat(year, month, day);
		var documentMessage = $("#documentMessage").val();

		var forZZZ = {};
		forZZZ["type"] = "read";
		forZZZ["name"] = "Report";
		if(userName != "")
			forZZZ["userName"] = userName;
		forZZZ["documentDate"] = documentDate;
		if(documentMessage != "")
			forZZZ["documentMessage"] = documentMessage;

		forZZZ["class"] = {};
		forZZZ["class"]["base"] = "KasovBonCLASSBASE";
		forZZZ["class"]["name"] = "KasovBonCLASSNAME";

		var zzzbase = "finance_zzzbase";
		var commands =	"#[cout;#[::>.;##[CoreCLASSBASE];##[CoreCLASSNAME];methods/public/ProcessRequest;["+zzzbase+";]\n";
		commands +=		"[[\n";
		commands +=		objectToZZZTXT(forZZZ, 0);
		commands +=		"]]]]";
		
		$.ajax({
			async: true,
			type: "POST",
			url: "zzzprog.ttm",
			contentType: "application/x-www-form-urlencoded;charset=UTF-8",
			data: {
				prog:""+commands
			}
		}).done(function(result) {
			var resultObject = zzztxtToObject(result);
			if(resultObject["errors"] == null && resultObject["result"] != null) {
				//var documentNumber = parseInt(Object.keys(resultObject["result"]["number"])[0], 16);
				//$("#documentNumber").val(documentNumber);
				
				function makeRow(profit, expense, balance, label) {
					var color;

					var row = '<tr>';

					color = "blue";
					if(profit < 0)
						color = "red";
					row += '<td style="color:'+color+'"><span class="u-pull-right">'+parseFloat(profit).toFixed(2)+'</span></td>';

					color = "blue";
					if(expense < 0)
						color = "red";
					row += '<td style="color:'+color+'"><span class="u-pull-right">'+parseFloat(expense).toFixed(2)+'</span></td>';

					color = "blue";
					if(balance < 0)
						color = "red";
					row += '<td style="color:'+color+'"><span class="u-pull-right">'+parseFloat(balance).toFixed(2)+'</span></td>';

					row += '<td>'+label+'</td>';

					row += '</tr>';
					
					return row;
				}
				
				if(Object.keys(resultObject["result"]["групи"]) != null) {
					var profit = 0;
					if(resultObject["result"]["групи"]["приход"] != null)
						profit = Object.keys(resultObject["result"]["групи"]["приход"])[0];
					
					var expense = 0;
					if(resultObject["result"]["групи"]["разход"] != null)
						expense = Object.keys(resultObject["result"]["групи"]["разход"])[0];
					
					var balance = profit - expense;

					$("table.report tbody").append(makeRow(profit, expense, balance, "Всичко"));
				}
				
				function reportItems(items, label) {
					for(var item in items) {
						var profit = 0;
						if(items[item]["групи"]["приход"] != null)
							profit = Object.keys(items[item]["групи"]["приход"])[0];

						var expense = 0;
						if(items[item]["групи"]["разход"] != null)
							expense = Object.keys(items[item]["групи"]["разход"])[0];

						var balance = profit - expense;
						
						$("table.report tbody").append(makeRow(profit, expense, balance, label + item));
						
						if(items[item]["години"] != null) {
							reportItems(items[item]["години"], "година ");
						}
						else if(items[item]["месеци"] != null) {
							reportItems(items[item]["месеци"], "месец ");
						}
						else if(items[item]["дни"] != null) {
							reportItems(items[item]["дни"], "ден ");
						}
					}
				}
				
				if(resultObject["result"]["години"] != null) {
					reportItems(resultObject["result"]["години"], "година ");
				}

				if(resultObject["result"]["имена"] != null) {
					reportItems(resultObject["result"]["имена"], "име ");
				}

				return true;
			}
			KasovBon.EndRequest();
		});
	};

	KasovBon.attachEvents = function() {
		$.datepicker.regional['bg'] = {
			changeMonth: true,
			changeYear: true,
			closeText: 'Затвори', // set a close button text
			currentText: 'Днес', // set today text
			monthNames: ['Януари','Февруари','Март','Април','Май','Юни','Юли','Август','Септември','Октомври','Ноември','Декември'], // set month names
			monthNamesShort: ['Яну','Фев','Мар','Апр','Май','Юни','Юли','Авг','Сеп','Окт','Ное','Дек'], // set short month names
			dayNames: ['Неделя','Понеделник','Вторник','Сряда','Четвъртък','Петък','Събота'], // set days names
			dayNamesShort: ['Нед','Пон','Вто','Сря','Чет','Пет','Съб'], // set short day names
			dayNamesMin: ['Нд','Пн','Вт','Ср','Чт','Пт','Сб'], // set more short days names
			firstDay: 1,
			dateFormat: 'dd.mm.yy' // set format date
		};

		$.datepicker.setDefaults($.datepicker.regional['bg']);

		$("#documentDate").datepicker();
		$("#documentDate").datepicker("setDate", new Date());
		
		$(".paidVersion").attr("title", "Тази функционалност е достъпна в платената версия.");

		$("#SaveButton").click(function(event) {
			KasovBon.saveEntry();
		});
		$("#ReportButton").click(function(event) {
			KasovBon.report();
		});
		$("#DetailsButton").click(function(event) {
			$(".container.details").toggle();
			if($(".container.details").css('display') === "none")
				$("#DetailsButton").text("Подробна");
			else
				$("#DetailsButton").text("Обобщена");
		});
		$(".container.details").hide();
	};

	KasovBon.init = function() {
		KasovBon.attachEvents();
	};
}

$( document ).ready(function() {
	KasovBon.init();
});
